//月齢計算オブジェクト

/* 2008.11.12 Takayuki Honda
福原直人さん作成の　月齢計算 version 2.3
を参考にさせて頂きました。
http://news.local-group.jp/moonage/moonage.js.txt

=====================================================
注）私は月齢の知識は全く持ち合わせていません。
正確なデーターは海上保安庁のページを参考にして下さい
=====================================================

【メモ】
月齢 0 新月 (大潮)
月齢 1 (大潮)
月齢 2 (大潮)
月齢 3 (中潮)
月齢 4 (中潮)
月齢 5 (中潮)
月齢 6 (中潮)
月齢 7 (小潮)
月齢 8 (小潮)
月齢 9 (小潮)
月齢 10 (長潮)
月齢 11 (若潮)
月齢 12 (中潮)
月齢 13 (中潮)
月齢 14 (大潮)
月齢 15 (大潮)
月齢 16 (大潮)
月齢 17 (大潮)
月齢 18 (中潮)
月齢 19 (中潮)
月齢 20 (中潮)
月齢 21 (中潮)
月齢 22 (小潮)
月齢 23 (小潮)
月齢 24 (小潮)
月齢 25 (長潮)
月齢 26 (若潮)
月齢 27 (中潮)
月齢 28 (中潮)
月齢 29 (大潮)
*/


moonAgeObj = new function(){

	this.moonDate = new Date();//対象の日付
	this.age;//小数点付の月齢
	this.julian;//対象日付のユリウス通年

	//月齢を取得
	//引数はユリウス通年
	function getMoon(j){
		var k     = Math.floor((j - 2451550.09765) / 29.530589);
		var t     = k / 1236.85;
		var m = 2451550.09765
		             + 29.530589  * k
		             +  0.0001337 * t * t
		             -  0.40720   * Math.sin((201.5643 + 385.8169 * k) * 0.017453292519943)
		             +  0.17241   * Math.sin((2.5534 +  29.1054 * k) * 0.017453292519943);
		return m;
	}

	//ユリウス通年を取得　引数はDate型
	function getJulian(d){
		return d.getTime() / 86400000.0+2440587.5;
	}


	this.getGeturei = function(d){
		var j = getJulian(d);
		var m = getMoon(j);
		var a = "";
		if(m > j){
			m = getMoon(j - 1.0);
		}
		a = (j - m) + "";
		a = (a.split("."))[0];
		try{
			return Number(a);
		}catch(e){alert(e);};
	};


	this.getShio = function(d){
		var s = this.getGeturei(d);
		switch(s){
		case 0:return "大潮";break;
		case 1:return "大潮";break;
		case 2:return "中潮";break;
		case 3:return "中潮";break;
		case 4:return "中潮";break;
		case 5:return "中潮";break;
		case 6:return "小潮";break;
		case 7:return "小潮";break;
		case 8:return "小潮";break;
		case 9:return "長潮";break;
		case 10:return "若潮";break;
		case 11:return "中潮";break;
		case 12:return "中潮";break;
		case 13:return "大潮";break;
		case 14:return "大潮";break;
		case 15:return "大潮";break;
		case 16:return "大潮";break;
		case 17:return "中潮";break;
		case 18:return "中潮";break;
		case 19:return "中潮";break;
		case 20:return "中潮";break;
		case 21:return "小潮";break;
		case 22:return "小潮";break;
		case 23:return "小潮";break;
		case 24:return "長潮";break;
		case 25:return "若潮";break;
		case 26:return "中潮";break;
		case 27:return "中潮";break;
		case 28:return "大潮";break;
		case 29:return "大潮";break;
		default:
			alert("汐変換失敗 " + s);
		}

	};
};